/* define E3_CD for use on the E3 demo cd */

/* #define E3_CD */

#ifdef E3_CD

#include <sndsrv_abi.h>
abi_sndsrv_t *sndsrv;

#endif

#include "misc.h"
#include "s3mplay.h"
#include "vmu_icon.h"

int st_x = 0;
int st_i = 0;
int c_rot = 0;

volatile unsigned long *snd_dbg = (unsigned long*)0xa080ffc0;

void play_s3m(char *fn) 
{
    int idx, i, r;
    uint32 fd;
    unsigned char buffer[2048];
    
    spu->disable();
    
    fd = fs->open(fn, O_RDONLY);
    if (fd == 0) {
	return;
    }
    
    idx = 0x10000;
    /* Load 2048 bytes at a time */
    while ( (r=fs->read(fd, buffer, 2048)) > 0) {
	spu->memload(idx, buffer, r);
	idx += r;
    }
    fs->close(fd);
    
    spu->memload(0, s3mplay, sizeof(s3mplay));
    
    spu->enable();
    
    while (*snd_dbg != 3)
	thread->pass();
    
    while (*snd_dbg == 3)
	thread->pass();
}

void do_cube()
{
    static float z = 100.0f;
    poly_hdr_t poly;
    
    special_one_frame();

    stars_one_frame();

    plasma_one_frame();

    fire_one_frame();

    inter_one_frame();

    ta->begin_render();
    
    cube_one_frame(SIN(c_rot*2),0,z+COS(c_rot*2),c_rot);
    c_rot+=3;
     
    ta->commit_eol();

    shiver(y2k_tex, 1.0f, 16.0f);
	
    sinus_text(st_x, 32, 1, 1, 1, 1, 1, &scrolltext[st_i], 1, 1);
    st_x -= 4;
    if (st_x == -32) {
      st_i++;
      st_x = 0;
    }
    if (!(scrolltext[st_i]))
      st_i = 0;

    ta->commit_eol();
    ta->finish_frame();

    if (z > 5.0f)
	z -= 1.0f;

    if (st_i == 400) {
	while (z < 100.0f) {

	    z += 1.0f;

	    special_one_frame();
	    
	    stars_one_frame();
	    
	    plasma_one_frame();
	    
	    fire_one_frame();
	    
	    inter_one_frame();
	    
	    ta->begin_render();
	    
	    cube_one_frame(SIN(c_rot*2),0,z+COS(c_rot*2),c_rot);
	    c_rot+=6;
	    
	    ta->commit_eol();
	    
	    shiver(y2k_tex, 1.0f, 16.0f);
   
	    ta->commit_eol();
	    ta->finish_frame();
	}
	
    }
}

int brot = 0;

void do_beetle()
{
    static float z = 100.0f;
    poly_hdr_t poly;
    
    ta->begin_render();

    draw_beetle(0.0f, 0.0f, z, brot*4,brot*3,brot*2, 0.03f); 
    
    beetle_orbit(0.0f, 0.0f, z);
    
    brot += 3;

    ta->commit_eol();

    shiver(y2k_tex, 1.0f, 16.0f);

    sinus_text(st_x, 32, 1, 1, 1, 1, 1, &scrolltext[st_i], 1, 1);
    st_x -= 4;
    if (st_x == -32) {
      st_i++;
      st_x = 0;
    }
    if (!(scrolltext[st_i]))
      st_i = 0;

    ta->commit_eol();

    ta->finish_frame();

    if (z > 4.0f)
	z -= 1.0f;
 
    if (st_i >= 800) {
	while (z < 100.0f) {

	    z += 1.0f;

	    ta->begin_render();
	    
	    draw_beetle(0.0f, 0.0f, z, brot*4,brot*3,brot*2, 0.03f); 
	    
	    beetle_orbit(0.0f, 0.0f, z);
	    
	    brot += 3;
	    
	    ta->commit_eol();
	    
	    shiver(y2k_tex, 1.0f, 16.0f);

	    ta->commit_eol();
	    
	    ta->finish_frame();
	    
	}
	
    }
}

int done = 0;

void do_my_bidding()
{
    cont_cond_t cond;
    
    if (st_i < 400)
	do_cube();
    else
	do_beetle();
    if (st_i >= 800)
	done = 1;

    if (maple->cont_get_cond(maple->first_controller(), &cond) >= 0)
    	if (!(cond.buttons & CONT_START)) done = 1;
}

void do_outro()
{
    float a = 0.0f;
    unsigned int start;

  /* fade out y2kode */
  for(a = 1.0f; a >= 0.0f ; a -= 0.01f) {
      particle_calc_one_frame();
      ta->begin_render();
      npm_one_frame();
      ta->commit_eol();
      shiver(y2k_tex, a, 16.0f);
      particle_render_one_frame(1.0f);
      ta->commit_eol();
      ta->finish_frame();
  }
}

int credits_y = 480;
int credits_s = 0;
int credits_done = 0;
int exittro = 0;

void credits_one_frame()
{
    int i;
    static float a = 0.0f;

    if (a < 1.0f)
	particle_calc_one_frame();
    
    ta->begin_render();
    if (!exittro) {
      npm_one_frame();
      ta->commit_eol();
    } else {
      ta->commit_eol();
      shiver(zoom512, 0.8f, 0.0f);
    }

    if (a < 1.0f)
	particle_render_one_frame(1.0f - a);
    
    i = credits_s;
    while(!credits_done) {
	if (credits_y >= 480)
	    break;
	if (!strcmp(credits[i],"END"))
	    break;
	draw_string(320.0f - strlen(credits[i])*16, credits_y + (i-credits_s)*48, 5.0f, 1.0f, 1.0f, 1.0f, 1.0f, credits[i], 1.0f, 1.0f);
	i++;
    }

    if (strcmp(credits[credits_s+1],"END")) {

	credits_y -= 1.0f;    
	
	if (credits_y < -47) {
	    credits_s++;
	    credits_y = 0;
	}
    } else
	credits_done = 1;

    if (credits_done) {
	draw_string(320.0f - strlen("PRESS <START> TO EXIT")*8, 16.0f, 5.0f, a, 1.0f, 1.0f, 1.0f, "PRESS <START> TO EXIT", 0.5f, 0.5f);
	draw_string(320.0f - strlen("NAPALM / 2001")*16, 416.0f, 5.0f, a, 1.0f, 1.0f, 1.0f, "NAPALM / 2001", 1.0f, 1.0f);
	if (a < 1.0f)
	    a += 0.01f;
	else
	    exittro = 1;
    }

    ta->commit_eol();
    ta->finish_frame();
}

void do_credits()
{
    cont_cond_t cond;

    while(1) {
        if (maple->cont_get_cond(maple->first_controller(), &cond) >= 0)
	    if (!(cond.buttons & CONT_START)) break;
	credits_one_frame();
    }
}

void vmu_icon_init() {
        uint8 bitmap[48*32/8];
        int x, y, xi, xb;
        uint8 addr;

	addr = maple->first_vmu();
	if (!addr) return;
	
	memset(bitmap, 0, 48*32/8);        
        for (y=0; y<32; y++)
                for (x=0; x<48; x++) {
                        xi = x / 8;
                        xb = 0x80 >> (x % 8);
                        if (vmu_icon[(31-y)*48+(47-x)] == '.')
                                bitmap[y*(48/8)+xi] |= xb;
                }
        
        maple->vmu_draw_lcd(addr, bitmap);
}

int main()
{
    ta = lib_open("ta");
    if (ta == NULL) { printf("Can't open TA lib\r\n"); return -1; }
    fs = lib_open("fs");
    if (fs == NULL) { printf("Can't open FS lib\r\n"); return -1; }
    maple = lib_open("maple");
    if (maple == NULL) { printf("Can't open Maple lib\r\n"); return -1; }
    thread = lib_open("thread");
    if (thread == NULL) { printf("Can't open Thread lib\r\n"); return -1; }
    spu = lib_open("spu");
    if (spu == NULL) { printf("Can't open SPU lib\r\n"); return -1; }

    vmu_icon_init();

#ifdef E3_CD

    do {
	sndsrv = lib_open("sndsrv");
	if (!sndsrv) thread->pass();
    } while (sndsrv == NULL);

    sndsrv->mp3_stop(); /* make sure sndserver is stopped */

#endif

    title_init();
    stars_init();
    plasma_init();
    fire_init();
    inter_init();
    static_init();
    special_init();
    font_init();
    particle_init();
    beetle_init();
    rotozoom_init();

    play_s3m(S3M_FILE);
        
    do_title();
    
    while(!done) 
 	do_my_bidding();
    
    do_outro();
  
    do_credits();

    spu->disable();
    inter_shutdown();
    plasma_shutdown();
    stars_shutdown();
    fire_shutdown();
  
    return 0;
}
